#ifndef __COR0_H
#define __COR0_H

#include <stdio.h>

#define BOOLEAN int
#define FALSE   0
#define TRUE    1

#define NRDF 100
#define NSTR  90
#define NTITLE 8

#define WORD unsigned int
#define BYTE unsigned char

#define NDIR 3
#define X 0
#define Y 1
#define Z 2

/*   Coord File types  */
#define CF_NONE 0
#define CF_COR  1
#define CF_RCV  2



typedef struct
   {
   long     run,step;
   WORD     np,nd,page,nlayerbox,nlayerplot,navg,ndim;
   int      selkeep, nsel, nalloc;
   float    *c[NDIR], *cd[NDIR];
   float    *radius;
   BYTE     *t, *tag, *color, *symbol, *sel, *fill, *dispfl;
   float    rdftable[NRDF];
   float    box[NDIR], trans[NDIR];
   float    MaxCoord[NDIR];
   float    MinCoord[NDIR];
   BOOLEAN  boundrep[NDIR];
   WORD     orient[NDIR];
   float    vibp, dtime, time, tempc, strain, stress, temp, mass, cutoff;
   double   epot, etot, ekin, ebath;
   char     title[8][NSTR];
   }
   stepdata;

typedef struct
   {
   FILE *Ptr;
   int  Type;
   }
   CFILE;

int       readrcv  (FILE *, stepdata *   );
void      writercv (FILE *, stepdata *, BOOLEAN);
void      FreeStep (stepdata *);
stepdata *make_step(void);
void      readtype (FILE *, stepdata *   );
void      readilist(FILE *, stepdata *   );

BOOLEAN   ReadCorFile  (FILE *, stepdata *);
void      WriteCorFile (FILE *, stepdata *, BOOLEAN);
void      CalcMinMaxCoord (stepdata *, BOOLEAN, BOOLEAN);

/*  Functions to open both RCV and COR files (depending on name)  */
CFILE *OpenCoordinateFile   (char *FileName, char *CFileTypeStr);
BOOLEAN ReadCoordinateFile  (CFILE *, stepdata *);
void    WriteCoordinateFile (CFILE *, stepdata *, BOOLEAN);
void CloseCoordinateFile (CFILE *CFilePtr);



#endif
