#ifndef __hlgraph_H
#define __hlgraph_H

/*
************************************************************************
File Includes
************************************************************************
*/
#include <stdio.h>

/*
************************************************************************
Defines
************************************************************************
*/
#define WORD2 unsigned short
#define ULONG unsigned long
#define BYTE  unsigned char
#define BOOLEAN int
#define TRUE 1
#define FALSE 0

/*
************************************************************************
Function Prototypes
************************************************************************
*/

void GR_Line   (WORD2 x0, WORD2 y0, WORD2 x1, WORD2 y1, WORD2 Color);
void GR_Ver    (WORD2 y,  WORD2 x0, WORD2 x1, WORD2 Color);
void GR_Hor    (WORD2 x,  WORD2 y0, WORD2 y1, WORD2 Color);
void GR_Atom   (WORD2 x,  WORD2 y,  WORD2 Color, double Radius);
void GR_Char   (WORD2 x,  WORD2 y,  WORD2 Color, char c);
void GR_Printf (WORD2 x,  WORD2 y,  WORD2 Color, char *Format, ...);
void GR_WriteCompressedBitmap  (FILE *BitMapFile);
void GR_ReadCompressedBitmap   (FILE *BitMapFile);

void GR_Compress
(
BYTE *InputBitMap,
BYTE *CompressedBitMap,
WORD2 InputSize,
WORD2 *CompressedSize
);


void GR_Expand
(
BYTE *InputBitMap,
BYTE *ExpandedBitMap,
WORD2  InputSize,
WORD2 *ExpandedSize
);

BOOLEAN GR_IsBigEndian   (void);
void    GR_ReverseEndian (void *, int);



#endif
