#ifndef __LLGRAPH_H
#define __LLGRAPH_H

/*
************************************************************************
Defines
************************************************************************
*/
#define WORD2  unsigned short
#define ULONG unsigned long
#define BYTE  unsigned char
#define BOOLEAN int
#define TRUE 1
#define FALSE 0


/*
************************************************************************
Utility Macros
************************************************************************
*/

/*  Simple loop (this macro help reduce typos)  */
#define LOOP(INDEX,LIMIT) \
   for (INDEX=0; INDEX<(LIMIT); INDEX++)


/*
************************************************************************
Function Prototypes
************************************************************************
*/

BOOLEAN GR_OpenGraphics     (void);
void    GR_CloseGraphics    (void);
void    GR_SetGraphicsMode  (WORD2 GraphicsMode);
void    GR_SetTextMode      (void);
void    GR_GetResolution    (WORD2 *MaxX, WORD2 *MaxY, WORD2 *MaxColor);
void    GR_SetDisplayPage   (WORD2 Page);
void    GR_SetDrawPage      (WORD2 Page);
void    GR_ClearPage        (void);
void    GR_WritePixel       (WORD2 x, WORD2 y, WORD2 Color);
BYTE    GR_ReadPixel        (WORD2 x, WORD2 y);
ULONG   GR_GetDisplaySize   (void);
void    GR_ReadBuffer       (BYTE *Buffer, ULONG Offset, WORD2 *Size);
void    GR_WriteBuffer      (BYTE *Buffer, ULONG Offset, WORD2 *Size);
void    GR_SetBackgroundColor (WORD2);
WORD2    GR_GetOptimumBufferSize(void);

#endif
