#ifndef __STRSUB_H
#define __STRSUB_H

/*
************************************************************************
File Includes
************************************************************************
*/

/*
Include <string.h> so that possible {strcmpi} define can be overridden.
If string.h were not included first here, then this <strsub.h> might be
called first, and then the define of {strcmpi} in this file might be
over-ridden.
*/

#include <string.h>


/*
************************************************************************
Defines
************************************************************************
*/

#define BOOLEAN int
#define FALSE 0
#define TRUE 1

/*  Remove any previous definition of strcmpi */
#ifdef  strcmpi
#undef  strcmpi
#endif

#ifdef __cplusplus
extern "C"
	{
#endif

	char   *strhed  (char **);
	char   *strlin  (char **);
	double  dblstr  (char **);
	int     intstr  (char **);
	long    lngstr  (char **);
	void    upstr   (char  *);
	void    SkipWhiteSpace (char **);
	BOOLEAN IsComment (char *, char *);
	BOOLEAN IsBlank   (char *);
	int     strcmpi   (const char *, const char *);

#ifdef __cplusplus
	}
#endif

#ifdef ULTRIX
char   *strdup  (char *);
#endif

#endif
